3 # Author: Alan J. Pippin (apippin@pippins.net)
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
28 ##############################################################################
29 # Local Machine Settings:
30 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
31 # and the local conf file created by each local machine (rip_dvd.conf)
32 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
33 # This will allow you to override all the default values to meet your needs
34 # in a way that won't get clobbered when you pull updates from my GIT repo.
35 ##############################################################################
36 config="${0%/*}/rip_dvd.conf"
37 [ -e "${config}.dist" ] && . ${config}.dist
38 [ -e "${config}" ] && . ${config}
40 ##############################################################################################
41 # Command line processing
42 ##############################################################################################
52 typeset profile="xvidvhq"
54 typeset -i keep_isofile=0
55 typeset -i keep_vobfile=0
56 typeset -i keep_dvdfolder=0
57 typeset -i keep_intermediate_files=0
58 typeset -i make_final_dest_vob=0
59 typeset -i make_final_dest_iso=0
60 typeset -i make_final_dest_folder=0
61 typeset -i make_final_dest_comp=0
63 typeset -i show_usage=0
64 typeset -i mirror_mode=0
65 typeset -i target_bitrate=0
66 typeset -i target_size=0
67 typeset -i audio_2ch=0
68 typeset -i invalid_feature_title=0
69 typeset -i feature_title_override=0
70 typeset -i mplayer_dumpstream_incompatibility=0
72 while (($#)) && getopts 2mvifkxht:n:d:b:s:t:a:p:e: opt "$@"
77 (b) target_bitrate=$OPTARG;;
78 (s) target_size=$OPTARG;;
80 (v) make_final_dest_vob=1;;
81 (i) make_final_dest_iso=1;;
82 (f) make_final_dest_folder=1;;
83 (x) make_final_dest_comp=1;;
85 (k) keep_intermediate_files=1;;
86 (t) feature_title_override=$OPTARG;;
89 (e) extension=$OPTARG;;
92 (:) echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
93 (\?) echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
100 echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
101 echo >&2 "Revision $REV"
103 echo >&2 " -d <destdir> Specify the destination directory to store the ripped DVD to"
104 echo >&2 " -n <dvdname> Specify a path to a DVD folder or file to process:"
105 echo >&2 " 1) If this option is not specified, the DVD will be ripped from $dev"
106 echo >&2 " 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
107 echo >&2 " 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
108 echo >&2 " 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
109 echo >&2 " 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
110 echo >&2 " -p <profile> Specify which encoding profile to use in -x mode as shown below:"
111 echo >&2 " - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
112 echo >&2 " - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
113 echo >&2 " - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
114 echo >&2 " - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
115 echo >&2 " - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
116 echo >&2 " - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
117 echo >&2 " - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
118 echo >&2 " - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
119 echo >&2 " -e <ext> Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
120 echo >&2 " If you run multiple instances of this script ripping the same DVD, you need to specify this option."
121 echo >&2 " -m Make a mirror image of the DVD and save it as a DVD ISO file"
122 echo >&2 " The default operation is non-mirror mode where only the main"
123 echo >&2 " feature title will be ripped."
124 echo >&2 " -v Make the final image a DVD VOB file"
125 echo >&2 " -i Make the final image a DVD ISO file"
126 echo >&2 " -f Make the final image a DVD folder"
127 echo >&2 " -x Make the final image a compressed file based on your profile selection"
128 echo >&2 " You must also specify the target size or bitrate using the '-s' or '-b' options"
129 echo >&2 " -s <size> Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
130 echo >&2 " -b <bitrate> Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"
131 echo >&2 " -a <W:H> Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
132 echo >&2 " <W> If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
133 echo >&2 " The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
134 echo >&2 " -2 Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
135 echo >&2 " -k Keep the intermediate files (good for debugging)"
136 echo >&2 " In -x mode, run with this option to keep the original .VOB file"
137 echo >&2 " By default, all intermediary files are deleted. Only the final image is kept"
138 echo >&2 " -t <title> Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
139 echo >&2 " -w Set the sh Execute/Verbose flag (causes every command to be echoed)"
144 if (($errors)) || (($show_usage))
149 # Sanity Check - Command Line Options
150 if [ "$dest" == "" ]; then
151 echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
155 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
156 echo "-E- You can't specify a bitrate, target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
160 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
161 echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
165 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] &&
166 [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
167 echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
171 if [ $mirror_mode -eq 1 ]; then
172 if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] ||
173 [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
174 echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
179 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
180 if [ "$aspect" != "" ]; then
181 echo "$aspect" | grep -q "x"
183 echo "-E- You must specify the aspect option with a value whose format is W:H"
186 echo "$aspect" | grep -q ":"
188 SCALE=",scale -zoom -sws 9 -xy $aspect"
190 SCALE=",scale=$aspect"
195 # Sanity Check - Key executables
196 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
197 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
198 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
199 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
200 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
201 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
202 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
203 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
205 ##############################################################################################
208 if [ -z "$dvdname" ]; then
209 # make sure the DVD device is accessible
210 volname $dev > /dev/null 2>&1
212 echo "-E- Can't access the DVD device $dev"
215 # now capture the volume name from the device
216 dvdname=`volname $dev | awk '{ print $1 }'`
219 # check to see if dvdname is a full path to a real directory
220 # if it is, set dvdname and dvdpath appropriately
221 if [ -d "$dvdname" ]; then
223 dvdname=`basename "$dvdname"`
225 if [ -z "$dvdname" ]; then
226 echo "-E- Unable to extract dvdname from path: $dvdpath"
229 if [ ! -d "$dvdpath/VIDEO_TS" ]; then
230 echo "-E- You must supply a full path to a valid DVD folder with this option"
235 # Check to see if dvdname is a full path to a file
236 if [ -f "$dvdname" ]; then
239 # check to see if dvdname is a full path to an MPG2 (VOB) file
240 # if it is, set dvdname and vobfile appropriately
241 file "$dvdname" | grep -q "MPEG"
243 # It is a valid MPEG2 file, now strip the extension off our dvdname
245 dvdname=`basename "$dvdname"`
246 dvdname=${dvdname%.[^.]*}
251 # check to see if dvdname is a full path to an ISO file
252 # if it is, set dvdname and isofile appropriately
253 file "$dvdname" | grep -q -e "ISO" -e "UDF"
255 # It is a valid ISO file, now strip the extension off our dvdname
257 dvdname=`basename "$dvdname"`
258 dvdname=${dvdname%.[^.]*}
263 # If we didn't find a handler for the file above, complain
264 if [ $valid_file -eq 0 ]; then
265 echo "-E- Unsupported file type: $vobfile"
272 # remove bad characters from the dvdname
273 dvdname=${dvdname%.} # remove trailing '.' character
275 # add the suffix extension to the end of the dvdname
276 dvdname=$dvdname$extension
278 # make a "safe" dvdname (remove special characters)
279 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
281 # Make sure we have a non-empty dvdname
282 if [ -z "$dvdname" ]; then
283 echo "-E- unable to determine dvdname"
287 # make sure our vobfile value is set
288 if [ -z "$vobfile" ]; then
289 vobfile="$dest/$dvdname.VOB"
292 # set up some variables to hold various logfiles
293 logfile="$logdir/$dvdname.log"
294 passlogfile="$tmpdir/$safedvdname.log"
295 ddrescuelog=`tempfile`
296 dvdauthorlog=`tempfile`
300 # create the tmpdir if it doesn't already exist
301 if [ ! -d "$tmpdir" ]; then
304 echo "-E- Unable to create the tmpdir: $tmpdir"
309 # create the logdir if it doesn't already exist
310 if [ ! -d "$logdir" ]; then
313 echo "-E- Unable to create the logdir: $logdir"
318 ##############################################################################################
320 ##############################################################################################
322 if [ $keep_intermediate_files -eq 0 ]; then
323 [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
324 [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
325 [[ -e "$encodelog" ]] && rm -f "$encodelog"
326 [[ -e "$dumplog" ]] && rm -f "$dumplog"
328 [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
329 [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
330 [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
331 [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
337 if [[ -z "$1" ]]; then
338 msg="-E- control-c killed us"
342 echo -e 2>&1 "$msg" | tee -a "$logfile"
343 if [[ -n "$mailto" ]]; then
344 echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
346 keep_intermediate_files=1
350 # Call our cleanup functions on INT and EXIT signals
351 trap fatal_and_exit INT
354 ##############################################################################################
355 # processing functions
356 ##############################################################################################
358 # encode the vob file into a compressed file format
359 function encode_vob_file {
360 typeset -i found_profile=0
363 if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
365 final_output_file="$dest/$dvdname.avi"
366 mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
367 mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
368 mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
369 mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS"
371 # Very High Quality (16fps)
372 if [ "$profile" == "xvidvhq" ]; then
373 video_encoder_opts[0]="bitrate=$target_bitrate"
374 video_encoder_opts[1]="threads=$mencoder_threads"
375 video_encoder_opts[2]="chroma_opt"
376 video_encoder_opts[3]="vhq=4"
377 video_encoder_opts[4]="bvhq=1"
378 video_encoder_opts[5]="quant_type=mpeg"
379 video_encoder_opts[6]="autoaspect"
381 # High Quality (20fps)
382 if [ "$profile" == "xvidhq" ]; then
383 video_encoder_opts[0]="bitrate=$target_bitrate"
384 video_encoder_opts[1]="threads=$mencoder_threads"
385 video_encoder_opts[2]="chroma_opt"
386 video_encoder_opts[3]="vhq=2"
387 video_encoder_opts[4]="bvhq=1"
388 video_encoder_opts[5]="quant_type=mpeg"
389 video_encoder_opts[6]="autoaspect"
392 if [ "$profile" == "xvid" ]; then
393 video_encoder_opts[0]="bitrate=$target_bitrate"
394 video_encoder_opts[1]="threads=$mencoder_threads"
395 video_encoder_opts[2]="vhq=0"
396 video_encoder_opts[3]="turbo"
397 video_encoder_opts[4]="autoaspect"
400 for OPTS in "${video_encoder_opts[@]}"; do
401 mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
404 if [ $audio_2ch -eq 0 ]; then
405 # These options produce good 6 channel audio for linux and windows
406 mencoder_audio_opts="-oac copy"
407 # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
408 mencoder_audioch_opts[0]="-channels 6 -af channels=6"
409 mencoder_audioch_opts[1]="-af channels=6"
410 mencoder_audioch_opts[2]=""
412 # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
413 mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
414 mencoder_audioch_opts[0]=""
419 # MP4 encoding profiles
420 if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
422 final_output_file="$dest/$dvdname.mp4"
423 mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
424 mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
425 mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
426 mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
428 # Very High Quality (6fps)
429 if [ "$profile" == "mp4vhq" ]; then
430 video_encoder_opts[0]="bitrate=$target_bitrate"
431 video_encoder_opts[1]="threads=$mencoder_threads"
432 video_encoder_opts[2]="subq=6"
433 video_encoder_opts[3]="frameref=5"
434 video_encoder_opts[4]="bframes=3"
435 video_encoder_opts[5]="8x8dct"
436 video_encoder_opts[6]="me=umh"
437 video_encoder_opts[7]="b_pyramid"
438 video_encoder_opts[8]="weight_b"
439 video_encoder_opts[9]="partitions=all"
441 # High Quality (13fps)
442 if [ "$profile" == "mp4hq" ]; then
443 video_encoder_opts[0]="bitrate=$target_bitrate"
444 video_encoder_opts[1]="threads=$mencoder_threads"
445 video_encoder_opts[2]="subq=5"
446 video_encoder_opts[3]="frameref=2"
447 video_encoder_opts[4]="bframes=3"
448 video_encoder_opts[5]="8x8dct"
449 video_encoder_opts[6]="b_pyramid"
450 video_encoder_opts[7]="weight_b"
453 if [ "$profile" == "mp4" ]; then
454 video_encoder_opts[0]="bitrate=$target_bitrate"
455 video_encoder_opts[1]="threads=$mencoder_threads"
456 video_encoder_opts[2]="subq=4"
457 video_encoder_opts[3]="bframes=2"
458 video_encoder_opts[4]="b_pyramid"
459 video_encoder_opts[5]="weight_b"
462 for OPTS in "${video_encoder_opts[@]}"; do
463 mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
466 if [ $audio_2ch -eq 0 ]; then
467 # These options produce good 6 channel audio for linux and windows
468 #mencoder_audio_opts="-oac copy"
469 # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
470 #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
471 #mencoder_audioch_opts[1]="-af channels=6"
472 #mencoder_audioch_opts[2]=""
473 mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
474 mencoder_audioch_opts[0]="-channels 6 -srate 48000"
476 # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
477 #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
478 #mencoder_audioch_opts[0]=""
479 mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
480 mencoder_audioch_opts[0]="-channels 2 -srate 48000"
485 # iphone and ipod MP4 profiles
486 if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
488 if [ "$profile" == "iphone" ]; then
490 # scale width to 480, set height appropriately, but keep a multiple of 16
491 #SCALE=",scale=480:-10"
492 # scale the video down however far is necessary to fit in 480x320
493 SCALE=",dsize=480:320:0,scale=-8:-8"
496 # scale width to 320, set height appropriately, but keep a multiple of 16
497 #SCALE=",scale=320:-10"
498 # scale the video down however far is necessary to fit in 320x240
499 SCALE=",dsize=320:240:0,scale=-8:-8"
501 final_output_file="$dest/$dvdname.mp4"
502 mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
503 mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
504 mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
505 mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
506 video_encoder_opts[0]="bitrate=$target_bitrate"
507 video_encoder_opts[1]="threads=$mencoder_threads"
508 video_encoder_opts[2]="vbv_maxrate=1500"
509 video_encoder_opts[3]="vbv_bufsize=2000"
510 video_encoder_opts[4]="nocabac"
511 video_encoder_opts[5]="me=umh"
512 video_encoder_opts[6]="subq=6"
513 video_encoder_opts[7]="frameref=6"
514 video_encoder_opts[8]="trellis=1"
515 video_encoder_opts[9]="level_idc=30"
516 video_encoder_opts[10]="global_header"
517 video_encoder_opts[11]="bframes=0"
518 video_encoder_opts[12]="partitions=all"
519 for OPTS in "${video_encoder_opts[@]}"; do
520 mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
523 mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
524 mencoder_audioch_opts[0]="-channels 2 -srate 48000"
527 if [ $found_profile -eq 0 ]; then
528 fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
531 # Do not edit this line. $mencoder_video_encoder_opts must be last
532 mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
537 # Set some options based on which pass we are in
538 mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
539 [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
540 [ $PASS -eq 1 ] && output_file="/dev/null"
541 [ $PASS -eq 2 ] && output_file="$final_output_file"
543 # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
544 for CH_OPTS in "${mencoder_audioch_opts[@]}";
546 echo -e " Encoding pass $PASS"
547 echo -e "\n Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
548 mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
550 grep -q "\[channels\] Invalid" $encodelog
554 echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
558 if [ $mencoder_retval != 0 ]; then
559 fatal_and_exit "-E- Unhandled mencoder error"
562 # Concatenate the encode log to our main log file, greping out unwanted lines
563 cat $encodelog | grep -v "Pos:" >> "$logfile"
568 function make_dvd_iso_image {
572 # check to see if we have a dvdpath to rip from instead of $dev
573 if [ -z "$dvdpath" ]; then
574 # load the CSS codes in the DVD drive
575 lsdvd $dev >> "$logfile"
577 fatal_and_exit "-E- lsdvd $dev failed"
580 # read the DVD, ignoring/skipping CRC errors
581 ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
583 fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
585 cat "$ddrescuelog" >> "$logfile"
587 # rip from a path instead
588 make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
592 function make_dvd_iso_image_from_folder {
598 echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
600 # make an iso image out of our directory
601 echo " mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
602 mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
604 # set the audio languages from the iso if it exists and is non-zero in size
605 if [ -s "$dst" ]; then
606 get_feature_title "$dst"
607 get_audio_id_from_iso "$dst"
610 # make sure we were able to create the iso image from the folder given to us
611 if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
612 echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
613 echo " Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
614 # remove the bad iso file
615 [[ -e "$dst" ]] && rm -f "$dst"
616 # get the feature title from the DVD folder
617 get_feature_title "$dvdpath"
618 # create our main VOB file from the ISO
619 create_main_vob_with_mplayer "$dvdpath"
620 # get our audio id from the VOB file
621 get_audio_id_from_vob "$vobfile"
625 function make_dvdbackup_folder_image {
626 # extract the feature title from the DVD image
627 echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
628 [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
629 dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
631 fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
635 function make_dvdauthor_folder_image {
636 # create a new DVD video of the feature title
637 echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
638 [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
639 dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
640 cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
642 # There is a chance that dvdauthor won't like some of the VOBs.
643 # We can't tell ahead of time which ones it will choke on.
644 # So, we need to run it over and over again until it can process
645 # all the VOBs. If it can't handle one of them, run it through
646 # mencoder to fix it and try again. These errors are typically
647 # present due to the copy protection that ddrescue removed.
648 grep -q "SCR moves" $dvdauthorlog
649 while [ $? == 0 ]; do
650 # fix bad vobs that get the "SCR moves backwards" error:
651 # STAT: Processing VTS_01_0.VOB...
652 # ERR: SCR moves backwards, remultiplex input.
653 badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
654 if [[ ! -f "$badvob" ]]; then
655 fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
657 echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
658 cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
659 mv -f $badvob.fixed $badvob
660 echo "-> Creating DVD video $dest/$dvdname"
661 dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
662 cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
663 grep -q "SCR moves" $dvdauthorlog
667 function get_feature_title {
669 # if a feature title was given on the command line, use it
670 if [ $feature_title_override -ne 0 ]; then
671 feature_title=$feature_title_override
674 # otherwise, use lsdvd to figure it out
675 if [ $ripdvd -eq 1 ]; then
676 feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
678 feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
682 function create_main_vob_with_cat {
683 # cd to the feature title DVD folder
684 pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
686 fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
689 # concatenate all the VOBs together into 1 giant VOB
690 vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
691 cat $vobs > "$tmpdir/$dvdname.VOB"
693 # cd back to the dir we started from
694 popd > /dev/null 2>&1
697 function create_main_vob_with_mplayer {
699 # argument processing
703 # make sure we have a valid feature title
704 if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
705 fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
708 # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
709 if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
710 msg="-E- We detected an mplayer dumpstream incompatibility earlier."
711 msg="$msg We also detected another condition that requires us to use dumpstream. "
712 msg="$msg\n Unable to rip this DVD in the mode you requested."
713 fatal_and_exit "$msg"
716 # use mplayer to create the main VOB file
717 echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
718 echo " mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
719 mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
721 cat $dumplog | grep -v "^A:" >> "$logfile"
722 fatal_and_exit "-E- Mplayer Failed"
724 cat $dumplog | grep -v "^A:" >> "$logfile"
725 [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
728 function get_audio_id_from_iso {
729 # Adjust our audio ID to find the english audio stream
730 # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
734 mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
735 grep -q "aid: $aid" $aidcheck
736 while [ $? == 1 ] && [ $aid -lt 159 ]; do
738 grep -q "aid: $aid" $aidcheck
740 [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
741 echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
742 # mencoder default DVD audio track language selection (english)
743 lang_opts="-aid $aid -alang en"
746 function get_crop_from_iso {
748 echo "-> Detecting black frame border crop value from ISO file"
749 echo " mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
750 mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
751 [[ -e "md5sums" ]] && rm -f "md5sums"
752 CROP=`cat $dumplog | grep CROP | tail -1`
753 echo " Found crop value of $CROP" >> "$logfile"
757 CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
758 echo " Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
759 if [ -z "$CROP" ]; then
760 echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
763 if [ $CROPCHECK -lt 0 ]; then
768 echo " Setting mencoder crop filter to: $CROP"
771 function get_crop_from_vob {
773 echo "-> Detecting black frame border crop value from VOB file"
774 echo " mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
775 mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
776 [[ -e "md5sums" ]] && rm -f "md5sums"
777 CROP=`cat $dumplog | grep CROP | tail -1`
778 echo " Found crop value of $CROP" >> "$logfile"
782 CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
783 echo " Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
784 if [ -z "$CROP" ]; then
785 echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
788 if [ $CROPCHECK -lt 0 ]; then
793 echo " Setting mencoder crop filter to: $CROP"
796 function get_audio_id_from_vob {
797 # Adjust our audio ID to find the english audio stream
798 # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
802 mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
803 grep -q "Found audio stream: $aid" $aidcheck
804 while [ $? == 1 ] && [ $aid -lt 159 ]; do
806 grep -q "Found audio stream: $aid" $aidcheck
808 [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
809 echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
810 # mencoder default DVD audio track language selection (english)
811 lang_opts="-aid $aid -alang en"
814 function check_vob_for_corrupted_start {
815 # check to see if the beginning of the DVD has a form of copy protection
816 # where they have deliberately broken the first X number of frames of the DVD.
817 # If we don't skip these, our resulting VOB file will not play.
818 badvobcheck=`tempfile`
821 mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
823 fatal_and_exit "-E- Mencoder Failed"
825 grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
826 while [ $? == 0 ] && [ $skip -lt $endpos ]; do
827 (( skip = skip + 5 ))
828 echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
829 mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
831 fatal_and_exit "-E- Mencoder Failed"
833 grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
835 [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
837 # cat the giant VOB into mencoder to create a playable VOB file
838 cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
840 fatal_and_exit "-E- Mencoder Failed"
844 function check_vob_for_completeness {
845 # check to make sure we got out a complete VOB.
846 # there is another kind of copy protection where the VOB's may
847 # have "MPG EOF" frames in the middle of the stream.
848 # this causes mencoder to not process the entire VOB, and exit without any errors.
849 # detect this by seeing how much smaller the dst vob is from the src vob.
850 MAX_FILESIZE_DELTA_PERCENT=70
851 SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
852 DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
853 FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
854 if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
855 # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
856 echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
857 create_main_vob_with_mplayer "$isofile"
858 [[ -e "$dumplog" ]] && rm -f $dumplog
859 DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
860 FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
861 if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
862 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
867 function check_vob_for_too_many_video_packets {
868 # If our earlier algorithm to work around this failed, throw an error.
869 # check to see if this DVD has a protection scheme we don't know how to work around
870 # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
871 # for some reason, the video is black, while the audio rolls, then the video finally comes
872 # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of
873 # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
874 # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
875 grep -q "Too many video packets in the buffer:" "$logfile"
877 # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
878 echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
879 create_main_vob_with_mplayer "$isofile"
880 grep -q "Too many video packets in the buffer:" $dumplog
882 [[ -e "$dumplog" ]] && rm -f $dumplog
883 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
885 [[ -e "$dumplog" ]] && rm -f $dumplog
889 function check_vob_for_a52_crc_errors {
890 # Let's see if we can playback our newly created VOB file without any errors.
891 # if there are issues, let's detect them now, and try to recreate the VOB
892 # there are some forms of copy protection that have missed above, that evidence
893 # themselves when we try to playback the VOB file. This was added to deal with
894 # the "a52: CRC check failed" copy protection scheme.
897 echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
898 mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
899 cat $dumplog | grep -v "^A:" >> "$logfile"
900 errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
901 if [ $errors -gt $MAX_ERRORS ]; then
902 echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
903 create_main_vob_with_mplayer "$isofile"
904 echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
905 mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
907 cat $dumplog | grep -v "^A:" >> "$logfile"
908 fatal_and_exit "-E- Mplayer Failed"
910 cat $dumplog | grep -v "^A:" >> "$logfile"
911 errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
912 if [ $errors -gt $MAX_ERRORS ]; then
913 fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n I recommend using another ripping mode like '-m' or '-i'"
916 [[ -e "$dumplog" ]] && rm -f $dumplog
919 function calculate_bitrate_from_target_size {
920 # determine what our bitrate needs to be if a target size was specified instead
921 if [ $target_size -ne 0 ]; then
922 vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
923 ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
924 echo " With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
928 function create_dvdauthor_dvd_xml_file {
929 # make a dvdauthor xml menu file to create a valid DVD video from
930 # this script does a good job, but we'll still need to clean it up a bit after it runs
931 echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
932 makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
934 fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
937 # replace the first line of the xml file to remove the bad dest path
938 awk -v line=1 -v new_content="<dvdauthor>" '{
944 }' dvd.xml > dvd.xml.new
945 mv -f dvd.xml.new dvd.xml
947 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
950 # remove the "<video " property line from the xml file
951 cat dvd.xml | grep -v "<video" > dvd.xml.new
952 mv -f dvd.xml.new dvd.xml
954 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
957 # remove the extra <pgc>..</pgc> pairs
958 cat dvd.xml | awk 'BEGIN {x=1}
960 if ($0~"</pgc>") {x=0}
962 if ($0~"<pgc>") {x=1}
964 echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
965 mv -f dvd.xml.new dvd.xml
967 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
970 # remove the VTS_*_0.VOB file as this is just the main menu video clip
971 cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
972 mv -f dvd.xml.new dvd.xml
974 fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
978 function check_for_mplayer_dumpstream_incompatibility {
980 echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
982 if [ ! -e "$vobfile" ]; then
983 # mplayer dumpstream does not work on DVDs that obscure the feature title.
984 # A DVD that has 99 titles, where the longest title isn't the main feature
985 # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
986 # out what the feature title is. This script will run through that flow if we
987 # set use_mplayer_dumpstream to 0. Check for this here.
988 if [ $ripdvd -eq 1 ]; then
989 lsdvd $dev | grep -q "Title: 99"
991 lsdvd "$isofile" | grep -q "Title: 99"
993 # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
994 if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
995 if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
996 echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
997 echo " You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
998 echo " You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
999 invalid_feature_title=1
1001 echo " Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1002 echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1003 echo " You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1004 use_mplayer_dumpstream=0
1005 invalid_feature_title=1
1011 # There is another form of protection that causes the mplayer dumpstream to fail.
1012 # This can be detected by telling mplayer to parse the VOB file by copying its audio
1013 # video streams to a dummy output file (/dev/null). Do that here to check for that
1014 # problem before continuing.
1015 if [ -e "$vobfile" ]; then
1016 mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1017 mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1018 grep -q "Too many audio packets in the buffer" $dumplog
1019 if [ $? == 0 ]; then
1020 echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1021 use_mplayer_dumpstream=0
1022 mplayer_dumpstream_incompatibility=1
1024 [[ -e "$dumplog" ]] && rm -f $dumplog
1028 function fill_mythvideo_metadata {
1030 # This function must be passed the filename as an argument
1031 # The filename must be a full path to the file
1034 # Make sure the fill mythvideo metadata option has been set to 1
1035 if [ $fill_mythvideo_metadata -eq 0 ]; then
1036 echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1040 # If the fill mythvideo metadata script is present, run it
1041 # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1042 if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1043 echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1044 fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1046 echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1047 echo " Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1051 # remove the intermediate VOB file
1052 function remove_intermediate_vob_file {
1053 if [ $keep_intermediate_files -eq 0 ]; then
1054 [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1056 echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1060 # remove the original DVD image
1061 function remove_intermediate_iso_file {
1062 [[ $keep_isofile -eq 1 ]] && return 1
1063 if [ $keep_intermediate_files -eq 0 ]; then
1064 [[ -e "$isofile" ]] && rm "$isofile"
1066 echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1070 # remove the intermediate dvdbackup folder
1071 function remove_intermediate_dvdbackup_folder {
1072 if [ $keep_intermediate_files -eq 0 ]; then
1073 [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1075 echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1079 ##############################################################################################
1081 ##############################################################################################
1083 # Make a note of when this DVD rip started
1085 echo -e "\n$date DVD rip started" >> "$logfile"
1087 # Rip the DVD - Mirror Mode
1088 if [ $mirror_mode -eq 1 ]; then
1089 echo "-> Ripping DVD $dvdname to $dest"
1091 # use ddrescue to make an ISO image of the disk
1092 make_dvd_iso_image "$dest/$dvdname.iso"
1094 # add this video data to the mythtv DB
1095 fill_mythvideo_metadata "$dest/$dvdname.iso"
1097 # eject the disk upon completion
1101 echo "$date DVD rip completed" | tee -a "$logfile"
1103 if [[ -n "$mailto" ]]; then
1104 cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1109 # Rip the DVD - Main Title Feature Only
1110 if [ $mirror_mode -eq 0 ]; then
1112 # Rip image from DVD
1113 if [ $ripdvd -eq 1 ]; then
1114 echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1115 # use ddrescue to make an ISO image of the disk
1116 make_dvd_iso_image "$tmpdir/$dvdname.iso"
1119 # Rip image from DVD path
1120 if [ -n "$dvdpath" ]; then
1121 echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1122 make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1125 # make sure our isofile value is set
1126 if [ -z "$isofile" ]; then
1127 isofile="$tmpdir/$dvdname.iso"
1130 if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1132 if [ ! -e "$vobfile" ]; then
1133 echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1135 # get the feature title from the ISO
1136 get_feature_title "$isofile"
1138 # get the crop value from the ISO
1141 # check for mplayer dumpstream incompatibilities
1142 # if they exist, this method will set this mode to 0.
1143 check_for_mplayer_dumpstream_incompatibility
1145 if [ $use_mplayer_dumpstream -eq 1 ]; then
1147 # get our audio id from the ISO file
1148 get_audio_id_from_iso "$isofile"
1150 # create our main VOB file from the ISO
1151 create_main_vob_with_mplayer "$isofile"
1153 # remove the intermediate VOB file
1154 remove_intermediate_vob_file
1156 # it's possible that our VOB is still corrupted in some manner
1157 # check to make sure it is still a good VOB before continuing.
1158 check_for_mplayer_dumpstream_incompatibility
1162 if [ $use_mplayer_dumpstream -eq 0 ]; then
1164 # use dvdbackup to make a DVD folder of the feature title
1165 make_dvdbackup_folder_image
1167 # create our main VOB file
1168 create_main_vob_with_cat
1170 # get our audio id from the VOB file
1171 get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1173 # check for corrupted VOB start
1174 check_vob_for_corrupted_start
1176 # check to make sure our VOB is complete
1177 check_vob_for_completeness
1179 # check to make sure our VOB doesn't have too many video packets
1180 check_vob_for_too_many_video_packets
1182 # check to make sure our VOB doesn't have a52 crc errors
1183 check_vob_for_a52_crc_errors
1185 # remove the intermediate VOB file
1186 remove_intermediate_vob_file
1190 # remove the intermediate ISO file
1191 remove_intermediate_iso_file
1194 echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1195 # get our audio id from the VOB file
1196 get_audio_id_from_vob "$vobfile"
1197 # get the crop value from the VOB
1201 # encode the VOB file to a compressed file format
1202 if [ $make_final_dest_comp -eq 1 ]; then
1203 echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1205 # determine what our bitrate needs to be if a target size was specified instead
1206 calculate_bitrate_from_target_size
1208 # encode the vob file into a compressed file format
1211 if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1212 [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1213 [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1215 echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1216 echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1220 # add this video data to the mythtv DB
1221 [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file"
1222 [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile"
1226 # use dvdbackup to make a DVD folder of the feature title
1227 make_dvdbackup_folder_image
1229 # cd to the feature title DVD folder
1230 pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1231 if [ $? != 0 ]; then
1232 fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1235 # create the dvd.xml file for dvdauthor
1236 create_dvdauthor_dvd_xml_file
1238 # make the final DVD folder image
1239 make_dvdauthor_folder_image
1241 # add this video data to the mythtv DB
1242 fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS"
1244 # cd back to the dir we started from
1245 popd > /dev/null 2>&1
1247 if [ $make_final_dest_iso -eq 1 ]; then
1249 # make an iso image out of our directory
1250 make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1252 # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory
1253 if [ -s "$dest/$dvdname.iso" ]; then
1254 if [ $make_final_dest_folder -eq 0 ]; then
1255 echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1256 # remove the folder of the DVD image now that we have a .iso version of it
1257 [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1260 # we created an empty iso file, remove it
1261 echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1262 echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1263 [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1266 # add this video data to the mythtv DB
1267 fill_mythvideo_metadata "$dest/$dvdname.iso"
1273 # remove the ddrescue DVD ISO image
1274 remove_intermediate_iso_file
1276 # remove the tmp dvdbackup folder of the DVD image
1277 remove_intermediate_dvdbackup_folder
1279 # eject the DVD disk upon completion
1280 [ $ripdvd -eq 1 ] && eject -T $dev
1283 echo "$date DVD rip completed" | tee -a "$logfile"
1285 if [[ -n "$mailto" ]]; then
1286 cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1291 ##############################################################################################